#
require "$LIB_PL/build_graph.pll";
1;
#
sub plot_rtr {
my($dir, $title, $mode, $date) = (@_);
my(@LOAD) = ();        # CPU load average
my(@MEM) = ();         # Free MEMORY
my(@RTR_NDOWNS) = ();  #   yes
my(@RTR_NN) =   ();    #    for yes 
my($MAX_MEM) = (4000);
#  $F_MEM{}->[]
my(%MTYPES);           # Type 
my(%F_MEM) = ();       #   type - 
my(%U_MEM);            #   type - 
my(%E_MEM);            # stat  yes type -   
my(%MA_MEM);           # M  () yes type.
my(%MI_MEM);           # M   yes type.
my(%MAF_MEM);          # M   yes type.
#
#
my ($idx);
#
my $monthly = 0;
my ($d_yy,$d_mon,$d_day) = split(/\./,$date);
if ( $d_day == 0 ) {
       $d_day = 1;
       $monthly = 1;
};
#
#  
my $S_Gx = 100;
my $S_Gy = 100;
my $maxcol = 4;
#
if ( $mode == 1 ) {
    $S_Gx = 100;
    $S_Gy = 240;
#    $maxcol = 2;
};
if ( $mode == 2 ) {
    $S_Gx = 200;
    $S_Gy = 400;
    $maxcol = 2;
};
#
my ($d,$t,$bw,$load,$load_m,$mem,$mem_m);
my ($st,$i, $nn);
#
#
#    
    my $I_detail = 4; # 4 graph  
    my $I_0 = 0;
    my $I_1 = 24 * $I_detail;
    my @I_label = ();
    $I_label[0]            =  "${F}0";
    $I_label[6*$I_detail]  =  "${F}6";
    $I_label[12*$I_detail] =  "${F}12";
    $I_label[18*$I_detail] =  "${F}18";
    my $I_name = "Hour";
    my $file = "$dir/$date";
    my $Nmarks = $I_detail;
if ( $monthly  ) {
    $I_detail = 0.5; # 1 graph  2 
    $I_0 = 0;
    $I_1 = int (31 * 24 * $I_detail) ;
    @I_label = ();
    for( $i = 5; $i < 31; $i += 5 ) {
	    $I_label[($i-1) * 12] = "${F}$i";
    };
    $I_name = "Day";
    $file = "cd $dir && cat $date* |";
    $Nmarks = int(24*$I_detail);
};
#
#   file
#
open(STAT,$file) || pt_fatal("No accounting file $file");
#
#  ,  ,   yes.
my ($yy, $mm, $dd, $hh, $min, $ss);
#
#     type   
#
my @group,$rest;
my $type;
my $Max_i = 0;
while ( <STAT> ) {
    chop;
    ($d,$t,$load,$load_m,$mem,$mem_m,$rest) = split(/[ \/,]+/,$_,7);
    $d =~ /^(\d+)\.(\d+)\.(\d+)$/;
    $yy = $1; $mm = $2; $dd = $3;
    $t =~ /^(\d+)\:(\d+)\:(\d+)$/;
    $hh = $1; $min = $2; $ss = $3;
    $idx = int($hh * $I_detail + $min / (60 / $I_detail) );
    $idx += int(24 * ($dd - 1 ) * $I_detail) if $monthly;
    #
    $Max_i = $idx if $Max_i < $idx;
    if ( $load =~ /\d+/ ) {
	$LOAD[$idx] += $load;
	$MEM[$idx]  += $mem;
	#
	$RTR_NN[$idx]++;
	@group = split(/[ \t]/,$rest);
	foreach $_ (@group) {
	       next if $_ !~ /^M/;
	       $_ =~ s/^M([^,]+),//;
	       $type = $1;
	       ($min,$min_m,$used,$used_m,$block,$block_m) = split(/[,\/]/,$_);
	       $MTYPES{$type} += 1;
	       if ( ! $F_MEM{$type} ) {
		       $N_MEM{$type}[$idx] = 1;
		       $F_MEM{$type}[$idx] = $min;
		       $U_MEM{$type}[$idx] = $used;
	       } else {
		       $N_MEM{$type}[$idx] += 1;
		       $F_MEM{$type}[$idx] += $min;
		       $U_MEM{$type}[$idx] += $used;
	       };
	};
    } else {
	   $RTR_NDOWNS[$idx]++ if $load =~ /^D/;
    };
};
#
#   file.   - (1) , (2)  for 
# (3)     ,      status.
#
#
if ( $monthly == 1 && $Max_i > 20 ) {
       $I_1 = $Max_i;
};
for ( $i = $I_0; $i <= $I_1; $i++) {
    $nn = $RTR_NN[$i];
    if ( $nn > 0 ) {
	$LOAD[$i] /= $nn;
	$MEM[$i] /= $nn;
	$MAX_MEM=4000      if $MEM[$i] > $MAX_MEM;
	$MAX_MEM=16000     if $MEM[$i] > $MAX_MEM;
	$MAX_MEM=32000     if $MEM[$i] > $MAX_MEM;
	$MAX_MEM=64000     if $MEM[$i] > $MAX_MEM;
	$MEM[$i]=$MAX_MEM  if $MEM[$i] > $MAX_MEM;
	foreach $_ (keys %MTYPES) {
	       $nn = $N_MEM{$_}[$i] if $N_MEM{$_};
	       next if ! $nn >= 1;
	       $F_MEM{$_}[$i] /= $nn;
	       $U_MEM{$_}[$i] /= $nn;
	       $E_MEM{$_}[$i] = 0;
	       #    
	       #   -     ,  stat
	       # (  800 K)    .
	       if ( $U_MEM{$_}[$i] > 1024 && $F_MEM{$_}[$i] < 800 ) {
		       $E_MEM{$_}[$i] = 800 - $F_MEM{$_}[$i];
		       $U_MEM{$_}[$i] -= $E_MEM{$_}[$i];
	       };
	       $mem = ($U_MEM{$_}[$i] + $F_MEM{$_}[$i]);
	       $MI_MEM{$_} = $F_MEM{$_}[$i]  if ( ! $MI_MEM{$_} || $MI_MEM{$_} > $F_MEM{$_}[$i] );
	       $MAF_MEM{$_} = $F_MEM{$_}[$i] if ( ! $MAF_MEM{$_} || $MAF_MEM{$_} < $F_MEM{$_}[$i] );
	       $MA_MEM{$_} = $mem if ( ! $MA_MEM{$_} || $MA_MEM{$_} < $mem );
	};
	#          -   
    };
};
#
#     .  , 
#  graphs  -  0, 
#  ,     , 
#  ,   stat  1 M,      .
#  -  ,      80%, 
#    .
my ( @O_MEM,@O_LOAD);
for ( $i = $I_0; $i <= $I_1; $i++) {
       if ( $RTR_NN[$i] > 0 && $MEM[$i] > 0 ) {
	       if ( $MEM[$i] < 1000 ) {
		       $O_MEM[$i] = 1000 - $MEM[$i];
		       $MEM[$i] = 1000; #   2 
	       };
	       $MEM[$i] = $MAX_MEM - $MEM[$i];
       };
       $RTR_NDOWNS[$i] *= 4;
       if ( $LOAD[$i] > 80 ) {
	       $O_LOAD[$i] = $LOAD[$i] - 80;
	       $LOAD[$i] = 80;
       };
};
#
#     graphs,   .
#
my $dt = localtime(time());

print <<EOFG1;
<TABLE>
<TR><TD COLSPAN=4 ALING=CENTER BGCOLOR=WHITE>$title </TD></TR>
<TR><TD>
EOFG1
my $ncol = 0;
#
#
#   
my @gifs = ($G_Black, $G_G, $G_O, $G_Blue);
my @Titles = ("${F}Load %","${F}(overload) %","${F}Failures");
my @pData = (\@LOAD, \@O_LOAD, \@RTR_NDOWNS);
plot_graph(\@gifs, $I_0, $I_1,"${F}Load CPU<br> %",\@Titles,"${F}$I_name \n",\@I_label ,\@pData,100,$S_Gy,$S_Gx,0, $Nmarks,0);
$ncol++;
print "</TD>\n";
#    for   yes 
#
foreach $type (keys %MTYPES) {
my @gifs = ($G_Black, $G_O,$G_R,$G_G);
my @Titles = ("${F}Busy memory K","${F}(last MB) K","${F}Free memory K");
my @pData = (\@{$U_MEM{$type}}, \@{$E_MEM{$type}}, \@{$F_MEM{$type}});
print "</TR>\n<TR>\n" if $ncol++ % $maxcol == 0;
print "<TD>\n";
$MA_MEM{$type} = 64 * int( ($MA_MEM{$type} + 63)/64);
$MI_MEM{$type} = 64 * int( ($MI_MEM{$type} + 63)/64);
$MAF_MEM{$type} = 64 * int( ($MAF_MEM{$type} + 63)/64);
plot_graph(\@gifs, $I_0, $I_1,"${F}$type memory K<br>${F}($MAF_MEM{$type}K -  $MI_MEM{$type}K)",\@Titles,"${F}$I_name \n",\@I_label ,\@pData,$MA_MEM{$type},$S_Gy,$S_Gx,0,  $Nmarks,0);
print "</TD>";
};
#      
my @gifs = ($G_Black, $G_G, $G_O, $G_Blue);
my @Titles = ("${F}Total memory K","${F}(last MB) K","${F}Failures");
my @pData = (\@MEM, \@O_MEM, \@RTR_NDOWNS);
print "</TR>\n<TR>\n" if $ncol++ % $maxcol == 0;
print "<TD>\n";
plot_graph(\@gifs, $I_0, $I_1,"${F}Busy memory<br>K",\@Titles,"${F}$I_name \n",\@I_label ,\@pData,$MAX_MEM,$S_Gy,$S_Gx,0,  $Nmarks,0);
print "</TD>";
#    .
print <<EOFSx;
</TR>
</TABLE>
</BODY>
</HTML>
EOFSx
return(0);
};








