#!/bin/sh
#
# For RELCOM only - load accounting data by network
#
OUT_S=/var/stat/DBDATA
OUT_HOST="extra.relcom.ru"
OUT_USER="ip-csspb"
OUT_DIR="/mnt/work/DAILY"
OLD="OLD"
IN_HOST="delta.relcom.ru"
IN_USER="ip-csspb"
#
IN_PWD="/mnt/work/CONFIG/channel.pwd"
LOCAL_PWD="/var/httpd/PWD/LINKS.pwd"
PATH="/usr/local/bin:$PATH"
#
cd    $OUT_S
mkdir $OLD > /dev/null 2>& 1
for i in *.hh *.dd
do
       test -f $i && scp $i "$OUT_USER@$OUT_HOST:$OUT_DIR/$i.tmp" && ssh $OUT_HOST -l $OUT_USER "mv $OUT_DIR/$i.tmp $OUT_DIR/$i" && mv $i $OLD/$i
done
cd OLD
gzip *.hh *.dd
#
#
#
scp "$IN_USER@$IN_HOST:$IN_PWD" $LOCAL_PWD.tmp
#
#
#
if grep -q '^###EOF$' $LOCAL_PWD.tmp
then
       sed 's/([0-9])//;/:$/d;/###EOF/d' $LOCAL_PWD.tmp | uniq > $LOCAL_PWD.new && mv -f $LOCAL_PWD $LOCAL_PWD.old && mv $LOCAL_PWD.new $LOCAL_PWD
fi
rm -f $LOCAL_PWD.tmp $LOCAL_PWD.new
