#!/usr/bin/perl
#
#   
#   'daily'
#     .
#    ,     .
# 1.   
$STAT="/var/stat/STAT";
# 2.   
$BIN="/usr/local/bin";
# 3.   
$CONF="/var/stat/Poll.conf";
# 4.  .
$OUT="/var/stat/opreports";
# 5.      
$OUT_S="/var/stat/DBDATA";
#
#  
#
# 7.   ,     
$NDAYS=7;
# 8.        .
$D_TIME=14;
# 9.        
$W_TIME=35;
#
#
#
# 10.        .
#      .
$MKREP="$BIN/snmpreport-h -r -c $CONF";
$MKTBL="$BIN/snmptbl -c $CONF";
# 11.    -r -c $CONF.
$LINKREP="$BIN/snmplinkrep -c $CONF ";
#  $LINKREP="$BIN/snmplinkrep -q -c $CONF";
#  -   
$RM="rm -f";
$MV="mv";
#
#
#  -i  _   _
$index_only = 0;
$index_only = 1 if ( $ARGV[0] eq '-i' );
#       . ,   .
$Nstats = 0;

#
#
$tm0 = time();
#
#
mkdir( $OUT_S,0775) if $OUT_S;
#      7   ,   
if ( ! $index_only ) {
    for ($i = 1; $i < $NDAYS+1; $i++ ) {
	$tm = $tm0 - ( $i * 3600 * 24);
	#     
	#
	system("echo '$RM  *.tmp';cd $OUT && $RM  *.tmp");
	$date_o = get_date($tm - $D_TIME*3600*24);
	system("echo '$RM  $date_o.*';cd $OUT && $RM  $date_o.*");
	$date_o = get_date($tm - $W_TIME*3600*24);
	system("echo '$RM  weekly-$date_o.*';cd $OUT && $RM  weekly-$date_o.*");
	#
	#     
	#
	$date = get_date($tm);
	#       , ,   
	#
	#     -  ,    _ _
	#     -   ,    _ _
	my (@dt) = localtime($tm);
	$weekly = ($dt[6] == 6 ? 1 : 0);
	#    - $monthly= ($dt[3] == 1 ? 1 : 0);
	#
	#      ,   .
	#      
	    if ( $LINKREP && ! -f "$OUT/$date.L.html" ) {
		print STDERR "$date - LINK stat started...\n";
		if ( $OUT_S) {
		    $Nstats++;
		    system("echo '$RM $OUT_S/*.tmp';$RM $OUT_S/*.tmp");
		    system("echo $LINKREP -s $OUT_S/$date.tmp $date;$LINKREP -s $OUT_S/$date.tmp $date > $OUT/$date.L.html.tmp && $MV $OUT_S/$date.tmp $OUT_S/LNK.$date.hh && $MV $OUT/$date.L.html.tmp $OUT/$date.L.html");
		} else {
		    system("echo $LINKREP  $date;$LINKREP  $date > $OUT/$date.L.html.tmp && $MV $OUT/$date.L.html.tmp $OUT/$date.L.html");
		};
		system("echo sed -n '/<HR >/,/<\\/HR >/p' $OUT/$date.L.html ;sed -n '/<HR >/,/<\\/HR >/p' $OUT/$date.L.html >> $OUT/LOG.html");
	    };
	    system("echo $MKREP $date;$MKREP $date > $OUT/$date.html.tmp && $MV $OUT/$date.html.tmp $OUT/$date.html") if $MKREP && ! -f "$OUT/$date.html";
	    system("echo $MKTBL $date;$MKTBL $date > $OUT/$date.tbl.tmp  && $MV $OUT/$date.tbl.tmp  $OUT/$date.T.html" ) if $MKTBL && ! -f "$OUT/$date.T.html";
	#
	#      ,   
	#       .
	#
	   if ( $weekly ) {
		   $date = get_date($tm - (3600 * 24 * 7));
		   system("echo $LINKREP -t weekly $date;$LINKREP -t weekly $date > $OUT/weekly-$date.L.html.tmp && $MV $OUT/weekly-$date.L.html.tmp $OUT/weekly-$date.L.html") if $LINKREP && ! -f "$OUT/weekly-$date.L.html";
		   system("echo $MKREP -t weekly $date;$MKREP -t weekly $date > $OUT/weekly-$date.html.tmp && $MV $OUT/weekly-$date.html.tmp $OUT/weekly-$date.html") if $MKREP && ! -f "$OUT/weekly-$date.html";
		   system("echo $MKTBL -t weekly $date;$MKTBL -t weekly $date > $OUT/weekly-$date.tbl.tmp  && $MV $OUT/weekly-$date.tbl.tmp  $OUT/weekly-$date.T.html")  if $MKTBL && ! -f "$OUT/weekly-$date.T.html" ;
	   };
    };
};
#
#     $OUT
do_index($OUT);
#   .     ,  .
if ( $CALL_STAT ) {
       system("$CALL_STAT");
};
exit(0);

#############################
sub get_date {
    my ($tm) = @_;
    my @dt = localtime($tm);
    $dt[4] += 1;
    #
    #   ,   .
    #
    $date = $dt[5]+1900;
    $date = ($dt[4] < 10 ? "$date.0$dt[4]" : "$date.$dt[4]");
    $date = ($dt[3] < 10 ? "$date.0$dt[3]" : "$date.$dt[3]");
    return($date);
};

#
#   .
#      index_head.html.
#      index_tail.html
#    ,       
#      .
#
sub do_index {
my ($dir) = @_;
my $file;
return 1 if ! opendir ODIR,"$dir";
if ( ! open(INDEX,">$dir/index.html.tmp")) {
       print STDERR "Can't create tmp file for index in $dir:", "".$!,"\n";
       return(1);
};
if ( open(HEADER,"$dir/index_head.html" )) {
       while ( $_ = <HEADER> ) {
	       print INDEX $_;
       };
       close(HEADER);
};
my %DAYS=();
my $WEEKS=();
my $dt;
while ( $_ = readdir(ODIR) ) {
       next if ! /(\d\d\d\d.\d\d.\d\d)/;
       $dt = $1;
       $cell = "";
       $cell="<TD><A HREF=\"$_\"></A></TD>" if /T\.html$/;
       $cell="<TD><A HREF=\"$_\"></A></TD>"  if /L\.html$/;
       $cell="<TD><A HREF=\"$_\"></A></TD>" if /\d\.html$/;
       next if ! $cell;
       if ( /^weekly/ ) {
	       $WEEKS{$dt} = "$WEEKS{$dt}$cell";
       } else {
	       $DAYS{$dt} = "$DAYS{$dt}$cell";
       };
};
closedir(ODIR);
print INDEX <<EOF;
<TABLE BORDER=2>
<TR>
       <TD COLSPAN=4> </TD>
</TR>
EOF
foreach $dt (sort keys %DAYS) {
print INDEX <<EOF;
<TR>
       <TD>$dt</TD>
       $DAYS{$dt}
</TR>
EOF
};
print INDEX <<EOF;
<TR>
       <TD COLSPAN=4> </TD>
</TR>
EOF
foreach $dt (sort keys %WEEKS) {
print INDEX <<EOF;
<TR>
       <TD>$dt</TD>
       $WEEKS{$dt}
</TR>
EOF
};
print INDEX <<EOF;
</TABLE>
EOF
if ( open(HEADER,"$dir/index_tail.html") ) {
       while ( $_ = <HEADER> ) {
	       print INDEX $_;
       };
       close(HEADER);
};
close(INDEX);
rename("$dir/index.html.tmp","$dir/index.html");
return(0);
};
